import 'package:flutter/services.dart';
import 'package:flutter_test/flutter_test.dart';
import 'package:tencent_im_sdk_plugin_222/enum/log_level.dart';
import 'package:tencent_im_sdk_plugin_222/models/v2_tim_value_callback.dart';
import 'package:tencent_im_sdk_plugin_222/tencent_im_sdk_plugin_222.dart';

void main() {
  const MethodChannel channel = MethodChannel('tencent_im_sdk_plugin_222');

  TestWidgetsFlutterBinding.ensureInitialized();

  setUp(() {
    channel.setMockMethodCallHandler((MethodCall methodCall) async {
      var a = Map<String, dynamic>();
      a['data'] = true;
      return a;
    });
  });

  tearDown(() {
    channel.setMockMethodCallHandler(null);
  });

  void initListener(data) {
    print(data.type);
  }

  test('init', () async {
    V2TimValueCallback<bool> res =
        await TencentImSDKPlugin.v2TIMManager.initSDK(
      sdkAppID: 1400187352,
      loglevel: LogLevel.V2TIM_LOG_ERROR,
      listener: initListener,
    );
    expect(true, res.data);
  });
}
